

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.TreeSet;

import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;

import jess.*;








//import jpl.Query;

import es.us.ccia.contexto.Contexto;
import es.us.ccia.contexto.elementos.FCAAttribute;
import es.us.ccia.contexto.elementos.FCAObject;
import es.us.ccia.dummy.contexto.dialogo.ResultCambios5;
import es.us.ccia.dummy.contexto.dialogo.VentanaArreglos;
import es.us.ccia.dummy.contexto.entsal.Entrada;
import es.us.ccia.dummy.contexto.entsal.Grabar;
import es.us.ccia.dummy.contexto.entsal.Importar;
import es.us.ccia.dummy.dibujo.*;
import es.us.ccia.dummy.teoria.Teoria;
import es.us.ccia.dummy.teoria.regiones.ListaElementos;
import es.us.ccia.dummy.teoria.relaciones.ListaRelacionRCC;
import es.us.ccia.razonador.Razonador;
import es.us.ccia.rcc.RCC;
import es.us.ccia.tiny.conceptos.Reticulo;
import es.us.ccia.tiny.sproduccion.BaseStem;
import es.us.ccia.tiny.sproduccion.SistemaProduccion;
import es.us.ccia.tiny.sproduccion.VentanaSuger;
import es.us.tad.*;












@SuppressWarnings({"serial","unchecked"})
public class EntornoGT extends GUI {

	public EntornoGT() {
		super("* TinyPaella *", 2);
		this.setUndecorated(false);
		
	}
 
	@Override
	public void menuAbrir() {	
		super.menuAbrir();
		Salida.Imprimirln("Esta es la apertura de Tiny");
		Salida.Imprimirln("Habria que calcular reticulo y demas.. no??");
		
		
		// Aqui hay que coger el contxexto actual y pasarlo a una matriz bidimensional
		
//		int [][] ct = Contexto.getMatriz();
		
		Reticulo R1 = new Reticulo();
		
		Razonador.inicializar(RCC.TinyRCC5,R1);

		System.out.println("He llegado al contexto.");

		
		
		
		System.out.println("Creados " + R1.numeroConceptos() + " conceptos");
		
		
		List lr = BaseStem.extraerImplicaciones();
		
		System.out.println("Hay " + lr.size() + " reglas");
		
		
		
		
		
		SistemaProduccion sp = new SistemaProduccion(lr);
		
		
		System.out.println("el motor es: " + sp.toString());
		
		
		
		
		
		
//		ConjuntoImplicaciones cImp = new ConjuntoImplicaciones();
		
		
		TinyPaella.setListaSugerenc(
				BaseStem.extraerImplicaciones());
//		System.out.println("He cargado las sugerencias..." + cImp.size());
		
		
		
		
		
		
		
		
		
		
		
		
	}	
	
	/**
	 * Esto es para la creacion del JavaDoc.
	 */
	public void menuImportarDel() {
		super.menuImportarDel();	
		System.out.println("Ahora calcular conceptos.");
	}
	
	@Override
	public void menuExportarDel() {
		// TODO Auto-generated method stub
		System.out.println("Prepocesar para grabar.");
		super.menuExportarDel();
		
	}


	public void botonEjecutarCambios(ListaElementos _nuevaconfig) {

		JOptionPane.showMessageDialog(this, 
				"Option not yet implemented",
				"Warning - Paella.",JOptionPane.OK_OPTION);
		   
		
		

	}

	@Override
	public void cambioListaClases(ArrayList _lista) {

		/** 
		 * QUE PASA CUANDO CAMBIO UNA SELECCION DE CLASE!!
		 */
		
		Teoria t = TinyPaella.getTeoria();

		if ((_lista.size())>1) {
			t.limpiarClases();
			
			ArrayList<FCAAttribute> listac = new ArrayList<FCAAttribute>();
			Iterator i = _lista.iterator();
			while (i.hasNext()) {
				FCAAttribute att  = Contexto.getAttribute((String)i.next());
				if (att == null) {
					System.out.println("CLASE no encontrada");
				} else {
					listac.add(att);				
				}
			}
			t.insertarClases(listac);
	
			t.Argumentos_a_RCC();
			
			
			
			t.calcularRegiones();
			
	//		System.out.println(t.getListaRelacionesRCC());
			
			pintarRelacionesRCC(t.getListaRelacionesRCC().toList());
	
	//		System.out.println("=====================================");
	//		System.out.println(t.getListaRegiones().size());
	//		System.out.println("=====================================");
					
			pintarVentanaDibujo(t.getListaRegiones());
					
	//		Salida.Imprimirln(t.getListaRelacionesRCC().toString());
	//		Salida.Imprimirln(Contexto.imprimir());
		
		} else {			
			pintarRelacionesRCC(new ListaRelacionRCC().toList());
			pintarVentanaDibujo(new ListaElementos());
		}
	}
	
	@Override
	public void cambioListaIndividuos(ArrayList _lista) {

		Teoria t = TinyPaella.getTeoria();
		t.limpiarIndiv();

		ArrayList<FCAObject> listai = new ArrayList<FCAObject>();
		Iterator i = _lista.iterator();
		while (i.hasNext()) {
			FCAObject obj = Contexto.getObject((String)i.next());
			if (obj == null) {
				Salida.Imprimirln("OBJETO no encontrado");
			} else {
				listai.add(obj);
			}
		}
		t.insertarIndividuos(listai);
		
		t.Argumentos_a_RCC();
		t.calcularRegiones();		
		pintarRelacionesRCC(t.getListaRelacionesRCC().toList());
		pintarVentanaDibujo(t.getListaRegiones());
		
		
	}
		
		
	public void cambioListaRelaciones() {
		
		/**************************************************/
		/*******  CAmbio de LISTA DE RELACIONNES   *********/
		/**************************************************/
		
		ListaElementos miteoria = TinyPaella.getTeoria().getListaRegiones();
		
//		if (!(arg0.getValueIsAdjusting())) {
			
			miteoria.desmarcarElementos();
			ArrayList lista = getListaRelaciones();
			Iterator i = lista.iterator();

			while (i.hasNext()) {
				StringTokenizer r = new StringTokenizer(i.next().toString(),"(),");
				r.nextToken();
				miteoria.marcarElemento(r.nextToken());
				miteoria.marcarElemento(r.nextToken());
			}
			repintarDibujo();
//		}

	}
	
	
	  

	
	
	
	
	
	
	
	
	
	

//	private void actualizarClases(ArrayList _lista) {
//
//		// TEORIA
//		Teoria miteoria = DummyPaella.getTeoria();
//
//		// INICIALIZACION
//		miteoria.limpiarClases();
//		miteoria.insertarClases(_lista);
//
//		// LLAMADA AL RAZONADOR
//		miteoria.Argumentos_a_RCC(); 
//		
//		// MINIMIZAR RELACIONES
////		miteoria.simplificarRelacionesRCC8();
//		
//		// CHR - PROLOG
//		miteoria.calcularRegiones();
//		
//		// DESDE EL DIBUJO
//		miteoria.Dibujo_a_RCC8();
////		miteoria.simplificarRelacionesRCC8();
//		
//		// ACTUALIZAR GRAFICOS
//		getVentanaRelaciones().actualizar(null);
//		getVentanaHistorial().limpiar();
//		getAreaDibujo().repaint();
//	
//	}
//	
//	private void actualizarIndividuos(ArrayList _lista) {
//		// TEORIA
//		Teoria miteoria = DummyPaella.getTeoria();
//
//		// INICIALIZACION
//		miteoria.limpiarIndiv();
//		miteoria.insertarIndividuos(_lista);
//			
//		// LLAMADA AL RAZONADOR
//		miteoria.Argumentos_a_RCC(); 
//				
//		// CHR - PROLOG
//		miteoria.calcularRegiones();
//		
//		// DESDE EL DIBUJO
//		miteoria.Dibujo_a_RCC8();
////		miteoria.simplificarRelacionesRCC8();
//		
//		// ACTUALIZAR GRAFICOS
//		getAreaDibujo().repaint();
//		getVentanaRelaciones().actualizar(null);
//		getVentanaHistorial().limpiar();
//
//	}

	@Override
	public void cambioVentanaDibujo(ListaElementos _lista) {
		// TODO Auto-generated method stub
//		System.out.println(_lista.toString());

		

//		
//		teoria.Dibujo_a_RCC8();
//		
//		ListaCambios lc = teoria.getCambiosRelaciones(activo.getArgumento());
//		lc.ejecutar();
//		
////		RazonadorRCC8.reCalcula();
//
//		teoria.Argumentos_a_RCC();
//		teoria.calcularRegiones();
//		teoria.Dibujo_a_RCC8();
//		
//		Salida.Imprimirln(Contexto.imprimir());
//		Salida.Imprimirln("---------------------");
//		Salida.Imprimirln(Razonador.escribirRel());
//		Salida.Imprimirln("---------------------");
//
//		
//		
//		g.getVentanaRelaciones().actualizar();
//		g.getVentanaHistorial().actualizar();
	
	
		
		
	}

	public void valueChanged(ListSelectionEvent e) {		
	}

	@Override
	public void hacerSugerencias(ArrayList<String> clases) {
		
		// Convertir las clases a FCAAttribute
		
		List hechos = new LinkedList();
		Iterator ci = clases.iterator();
		while (ci.hasNext()) {
			String nombre = (String)ci.next();
			hechos.add(Contexto.getAttribute(nombre));
		}
		
		List s = TinyPaella.getListaSugerenc();
		SistemaProduccion sp = new SistemaProduccion(s);		
		Collection resultado = sp.ejecutarCompleto(hechos);

		if (resultado.size()>0) {
			Collection opcion;
			VentanaSuger.initialize("Suggestion Tags",resultado);
			opcion = VentanaSuger.showDialog(null,null);

			if (opcion != null) {

				
				Teoria t = TinyPaella.getTeoria();
				
				
				
				// Anadir AL DIBUJO!!!
				Iterator ita1 = opcion.iterator();
				while (ita1.hasNext()) {
					FCAAttribute ind = (FCAAttribute)ita1.next();
//					System.out.println("f ==> " + ind);
					
					t.insertarClase(ind);
					
					
					
				}
				
				t.Argumentos_a_RCC();
				t.calcularRegiones();
				pintarRelacionesRCC(t.getListaRelacionesRCC().toList());
				pintarVentanaDibujo(t.getListaRegiones());
				
				
				
				
			}
		}
		
		
			
		
		
		
		
		
		
		
		
		
		
	}

	public void reiniciarContexto(){
		TinyPaella.getTeoria().reiniciarTeoria();
		
		getVetiq().reiniciar(Contexto.getAttributes());
		getVindiv().reiniciar(Contexto.getObjects());
		//	  vhist.actualizar();
		getVrel().actualizar(null);
		//	  	vdibujo.repaint();
	}


 
}
